



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS实现图的创建和遍历</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS实现图的创建和遍历</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:01:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>图分为无向图和有向图</p>
<p>图的存储结构有邻接矩阵、邻接表、十字链表、邻接多重表这四种，最常用的是前两种</p>
<p>本篇主要是利用邻接矩阵实现无向图的创建和遍历（深度优先、广度优先），深度优先其实就是二叉树里的前序遍历</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/715141/201811/715141-20181108202101533-69086465.png" />&nbsp;&nbsp;<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/715141/201811/715141-20181108203348547-1742307257.png" /></p>
<p>利用邻接矩阵（边数组）创建图</p>
<div>
<pre class="prettyprint linenums">let scanf = require('scanf');<br />
//定义邻接矩阵<br />
let Arr2 = [<br />
    [0, 1, 0, 0, 0, 1, 0, 0, 0],<br />
    [1, 0, 1, 0, 0, 0, 1, 0, 1],<br />
    [0, 1, 0, 1, 0, 0, 0, 0, 1],<br />
    [0, 0, 1, 0, 1, 0, 1, 1, 1],<br />
    [0, 0, 0, 1, 0, 1, 0, 1, 0],<br />
    [1, 0, 0, 0, 0, 0, 1, 0, 0],<br />
    [0, 1, 0, 1, 0, 1, 0, 1, 0],<br />
    [0, 0, 0, 1, 1, 0, 1, 0, 0],<br />
    [0, 1, 1, 1, 0, 0, 0, 0, 0],<br />
]

let numVertexes = 9, //定义顶点数<br />
    numEdges = 14; //定义边数

// 定义图结构<br />
function MGraph() {<br />
    this.vexs = []; //顶点表<br />
    this.arc = []; // 邻接矩阵，可看作边表<br />
    this.numVertexes = null; //图中当前的顶点数<br />
    this.numEdges = null; //图中当前的边数<br />
}<br />
let G = new MGraph(); //创建图使用

//创建图<br />
function createMGraph() {<br />
    G.numVertexes = numVertexes; //设置顶点数<br />
    G.numEdges = numEdges; //设置边数

    //录入顶点信息<br />
    for (let i = 0; i &lt; G.numVertexes; i++) {<br />
        G.vexs[i] = scanf('%s'); //String.fromCharCode(i + 65); ascii码转字符<br />
    }<br />
    console.log(G.vexs) //打印顶点

    //邻接矩阵初始化<br />
    for (let i = 0; i &lt; G.numVertexes; i++) {<br />
        G.arc[i] = [];<br />
        for (j = 0; j &lt; G.numVertexes; j++) {<br />
            G.arc[i][j] = Arr2[i][j]; //INFINITY;<br />
        }<br />
    }

    /**以下是手动录入的方式 */<br />
    // for (let k = 0; k &lt; G.numEdges; k++) {<br />
    //     console.log('输入边（vi,vj）上的下标i,下标j和权w:');<br />
    //     let rlt = scanf('%d,%d,%d');<br />
    //     let i = rlt[0], j = rlt[1], w = rlt[2];<br />
    //     G.arc[i][j] = w;<br />
    //     G.arc[j][i] = G.arc[i][j]; //无向图，矩阵对称<br />
    // }

    console.log(G.arc); //打印邻接矩阵<br />
}</pre>
</div>
<p>深度优先遍历</p>
<div>
<pre class="prettyprint linenums">let visited = []; //访问标志数组，遍历时使用

//邻接矩阵的深度优先递归算法<br />
function DFS(i) {<br />
    visited[i] = true;<br />
    console.log('打印顶点:', G.vexs[i]) //打印顶点 ,也可以其他操作<br />
    for (let j = 0; j &lt; G.numVertexes; j++) {<br />
        if (G.arc[i][j] == 1 &amp;&amp; !visited[j]) {<br />
            console.log(G.vexs[i], '-&gt;', G.vexs[j])<br />
            DFS(j) //对未访问的顶点进行递归<br />
        }<br />
    }<br />
}<br />
//邻接矩阵的深度遍历操作<br />
function DFSTraverse() {<br />
    for (let i = 0; i &lt; G.numVertexes; i++) {<br />
        visited[i] = false;<br />
    }<br />
    for (let i = 0; i &lt; G.numVertexes; i++) {<br />
        if (!visited[i])<br />
            DFS(i)<br />
    }<br />
}</pre>
</div>
<p>广度优先遍历</p>
<div>
<pre class="prettyprint linenums">//邻接矩阵的广度遍历算法<br />
function BFSTraverse() {<br />
    let queue = []; //初始化队列<br />
    for (let i = 0; i &lt; G.numVertexes; i++) {<br />
        visited[i] = false;<br />
    }<br />
    for (let i = 0; i &lt; G.numVertexes; i++) { //对每一个顶点做循环<br />
        if (!visited[i]) { //如果没有访问过就处理<br />
            visited[i] = true;<br />
            console.log('打印顶点：', G.vexs[i]) //也可以是其他操作<br />
            queue.push(i); //将此顶点入队列<br />
            while (queue.length != 0) { //当前队列不为空<br />
                queue.shift();<br />
                for (let j = 0; j &lt; G.numVertexes; j++) {<br />
                    //判断其他顶点若与当前顶点存在边且未访问过<br />
                    if (G.arc[i][j] == 1 &amp;&amp; !visited[j]) {<br />
                        visited[j] = true;<br />
                        console.log(G.vexs[i], '-&gt;', G.vexs[j])<br />
                        console.log('打印顶点：', G.vexs[j])<br />
                        queue.push(j) //将此顶点放入队列<br />
                    }<br />
                }<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>
<p>运行：</p>
<div>
<div>
<div>console.log('**********创建图结构**********');</div>
<div>createMGraph();</div>
<div>console.log('**********广度优先遍历**********');</div>
<div>DFSTraverse();</div>
<div>console.log('**********广度优先遍历**********');</div>
<div>BFSTraverse();</div>
</div>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/715141/201811/715141-20181108204036499-1637821051.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7dg0kq.html">opencv安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ew3nm8.html">DAO模式应用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j3z0gq.html">java5 Exchanger数据交换</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7pxj1q.html">Genymotion填坑之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm45ol9.html">C&plus;&plus;标准转换运算符 --四种</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdrv4y8.html">Java架构师之路：JAVA程序员必看的15本书</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj70zd9.html">ExtJs 4&period;2&period;1 报错：Uncaught TypeError&colon; Cannot call method &amp;&num;39&semi;getItems&amp;&num;39&semi; of null</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm20y09.html">使用php-emoji类让网页显示emoji表情</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wlmglq.html">BZOJ1631&colon; &lbrack;Usaco2007 Feb&rsqb;Cow Party</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdezz48.html">PL&sol;SQL文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnp0yv8.html">html5 新增语义标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13rn38.html">【Howie玩docker】-使用mono编译c&num;程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjjw0k8.html">分布式搜索elasticsearch 文献检索索引 入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey4n1k9.html">hdu 4277 USACO ORZ （dfs暴搜&plus;hash）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkodme8.html">arrayList LinkedList HashMap HashTable的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd3wxd9.html">Cygwin在线安装指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvzz08.html">python版mapreduce题目实现寻找共同好友</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m52gn8.html">Chrome的First Paint</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyk56j9.html">http协议无状态中的 &amp;quot&semi;状态&amp;quot&semi; 到底指的是什么？！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3d2x9.html">windows系统下输入法图标显示设置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8koeo43q.html">django系列7&period;2--django中的cookie和session基本操作&comma;浏览器登陆验证的不同实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qveyz419.html">C&plus;&plus;中指针运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e5nkg9.html">&lbrack;CISCO&rsqb; 交换机间链路聚合端口聚合</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1rkkx9.html">AWS 推出长期支持的 OpenJDK 免费分发版本 &mdash;&mdash; Amazon Corretto</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn21jrq.html">Oracle ltrim&lpar;&rpar; rtrim&lpar;&rpar; 函数详细用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qveykx19.html">sqlplus登录远程数据库与数据导出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnxgekq.html">【转载】MDX Step by Step 读书笔记&lpar;四&rpar; - Working with Sets &lpar;使用集合&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlgzdl9.html">一种很有意思的数据结构：Bitmap</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkzlyx8.html">【性能测试】：对WebSphere中间件的监控方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjyxmvq.html">DA14580&lowbar;583&lowbar;DK&lowbar;II开发板入门笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
